"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.contentModelTypescriptCodegen = exports.graphqlTypescriptCodegen = void 0;
var lodash_1 = __importDefault(require("lodash"));
var chalk_1 = __importDefault(require("chalk"));
var fs_1 = __importDefault(require("fs"));
var glob_1 = __importDefault(require("glob"));
var path_1 = __importDefault(require("path"));
var prompts_1 = __importDefault(require("prompts"));
var superagent_1 = __importDefault(require("superagent"));
var graphql_1 = require("graphql");
var utilities_1 = require("graphql/utilities");
var content_model_1 = require("./content-model");
var util_1 = require("./util");
var graphql_2 = require("./graphql");
function writeLogFunc(quiet) {
    if (quiet)
        return lodash_1.default.noop;
    return function (message) {
        var ts = new Date();
        var h = lodash_1.default.padStart("".concat(ts.getHours()), 2, "0");
        var m = lodash_1.default.padStart("".concat(ts.getMinutes()), 2, "0");
        var s = lodash_1.default.padStart("".concat(ts.getSeconds()), 2, "0");
        var mi = lodash_1.default.padStart("".concat(ts.getMilliseconds()), 3, "0");
        console.log("[".concat(chalk_1.default.gray("".concat(h, ":").concat(m, ":").concat(s, ".").concat(mi)), "] ").concat(message));
    };
}
function mapPrefix(prefixMap, v) {
    for (var key in prefixMap) {
        var val = prefixMap[key] || "";
        v = v.replace(key, val);
    }
    return v;
}
function exportInterfaceOrType(name, type) {
    if (type.startsWith("{")) {
        return "export interface ".concat(name, " ").concat(type);
    }
    else {
        return "export type ".concat(name, " = ").concat(type, ";");
    }
}
function generate(schema, doc, imports) {
    var _a = (0, graphql_2.resolveTypesSorted)(schema, doc, imports), usedNamedTypesSorted = _a.usedNamedTypesSorted, fragmentsSorted = _a.fragmentsSorted, operationsSorted = _a.operationsSorted, fragments = _a.fragments, fragmentDeps = _a.fragmentDeps;
    var types = "";
    var files = [];
    if (imports.embedImports) {
        imports.loadedImportsMap = {};
    }
    else {
        for (var _i = 0, _b = lodash_1.default.keys(imports.loadedImportsMap).sort(); _i < _b.length; _i++) {
            var impName = _b[_i];
            var imp = (0, util_1.nonNull)(imports.loadedImportsMap[impName], "import");
            types += "import { ".concat(imp.name, "Fragment } from \"").concat(mapPrefix(imports.prefixMap, imp.path), "/types\";\n\n");
        }
    }
    types += "export type ArbitraryObjectType = any;\n\n";
    for (var _c = 0, usedNamedTypesSorted_1 = usedNamedTypesSorted; _c < usedNamedTypesSorted_1.length; _c++) {
        var nt = usedNamedTypesSorted_1[_c];
        var t = schema.getType(nt.name);
        if ((0, graphql_1.isEnumType)(t)) {
            types += "export type ".concat(nt.name, " = ").concat((0, graphql_2.enumToString)(t), ";\n\n");
        }
        else if ((0, graphql_1.isInputObjectType)(t)) {
            var tt = (0, graphql_2.convertType)(t, undefined, fragments, imports.loadedImportsMap, true, true);
            tt.nullable = false; // hack: top level types are not nullable
            types += "".concat(exportInterfaceOrType(nt.name, (0, graphql_2.typeToString)(tt, 0, true)), "\n\n");
        }
        else {
            // must be a scalar type, skip it
        }
    }
    for (var _d = 0, fragmentsSorted_1 = fragmentsSorted; _d < fragmentsSorted_1.length; _d++) {
        var frag = fragmentsSorted_1[_d];
        types += "".concat(exportInterfaceOrType("".concat(frag.name, "Fragment"), (0, graphql_2.typeToString)(frag.value.type)), "\n\n");
        files.push({
            name: "fragments/".concat(frag.name, ".ts"),
            text: "export default ".concat(JSON.stringify((0, utilities_1.stripIgnoredCharacters)((0, graphql_1.print)(frag.value.node)) + "\n"), ";"),
        });
    }
    for (var _e = 0, operationsSorted_1 = operationsSorted; _e < operationsSorted_1.length; _e++) {
        var op = operationsSorted_1[_e];
        types += "".concat(exportInterfaceOrType(op.name, (0, graphql_2.typeToString)(op.value.operation, 0, false)), "\n\n");
        types += "".concat(exportInterfaceOrType("".concat(op.name, "Variables"), (0, graphql_2.typeToString)(op.value.variables, 0, true)), "\n\n");
        types += "export interface ".concat(op.name, "Meta {\n");
        types += "  __opType: ".concat(op.name, ", __opVariablesType: ").concat(op.name, "Variables, __tag: 'graphql-operation'\n");
        types += "}\n\n";
    }
    for (var _f = 0, operationsSorted_2 = operationsSorted; _f < operationsSorted_2.length; _f++) {
        var op = operationsSorted_2[_f];
        var fragsFromOp = {};
        (0, graphql_2.extractFragmentDeps)(op.value.node.selectionSet, fragsFromOp);
        var fragNames = lodash_1.default.keys(fragsFromOp).sort();
        var allDepImports = {};
        var allDepNames = {};
        for (var _g = 0, fragNames_1 = fragNames; _g < fragNames_1.length; _g++) {
            var fragName = fragNames_1[_g];
            var deps = {};
            (0, graphql_2.addFragmentDepsRecursive)(deps, [fragName], fragmentDeps, imports.loadedImportsMap);
            for (var _h = 0, _j = lodash_1.default.keys(deps).sort(); _h < _j.length; _h++) {
                var dep = _j[_h];
                var _k = lodash_1.default.split(dep, ":", 2), path_2 = _k[0], name_1 = _k[1];
                allDepNames[name_1] = true;
                allDepImports["import ".concat(name_1, " from \"").concat(mapPrefix(imports.prefixMap, path_2), "/fragments/").concat(name_1, "\";")] = true;
            }
        }
        var depNames = lodash_1.default.keys(allDepNames).sort();
        var depImports = lodash_1.default.join(__spreadArray(__spreadArray([], lodash_1.default.keys(allDepImports).sort(), true), ["import { ".concat(op.name, "Meta } from \"../types\";")], false), "\n");
        var strings = lodash_1.default.join(__spreadArray(__spreadArray([], depNames, true), [JSON.stringify((0, utilities_1.stripIgnoredCharacters)((0, graphql_1.print)(op.value.node)))], false), " + ");
        files.push({
            name: "operations/".concat(op.name, ".ts"),
            text: "".concat(depImports, "\nexport default (").concat(strings, ") as unknown as ").concat(op.name, "Meta;"),
        });
    }
    return {
        types: types,
        files: files,
    };
}
function writeFileIfChanged(writeLog, path, content) {
    try {
        var data = fs_1.default.readFileSync(path, "utf8");
        if (data === content) {
            writeLog("no changes in file \"".concat(path, "\""));
            return;
        }
    }
    catch (_a) { }
    fs_1.default.writeFileSync(path, content, "utf8");
    writeLog("writing data to file \"".concat(path, "\""));
}
function addTokenMaybe(token) {
    return function (req) {
        if (token)
            req.set("Authorization", "Bearer ".concat(token));
    };
}
function fetchSchema(writeLog, pathOrURL, token) {
    return __awaiter(this, void 0, void 0, function () {
        var resp, buf, introspectionQuery, resp, data;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    if (!lodash_1.default.startsWith(pathOrURL, "https://")) return [3 /*break*/, 5];
                    if (!lodash_1.default.endsWith(pathOrURL, ".graphql")) return [3 /*break*/, 2];
                    writeLog("fetching schema from remote file \"".concat(pathOrURL, "\""));
                    return [4 /*yield*/, superagent_1.default.get(pathOrURL).http2().responseType("arraybuffer").send()];
                case 1:
                    resp = _a.sent();
                    buf = resp.body;
                    return [2 /*return*/, (0, graphql_1.buildSchema)(new TextDecoder().decode(buf))];
                case 2:
                    writeLog("fetching schema via introspection query from \"".concat(pathOrURL, "\""));
                    introspectionQuery = (0, graphql_1.getIntrospectionQuery)({ descriptions: false, inputValueDeprecation: false });
                    return [4 /*yield*/, superagent_1.default
                            .post(pathOrURL)
                            .http2()
                            .accept("json")
                            .use(addTokenMaybe(token))
                            .send({ query: introspectionQuery })];
                case 3:
                    resp = _a.sent();
                    if (resp.body.errors)
                        throw new Error("failed fetching schema: ".concat(resp.body.errors));
                    return [2 /*return*/, (0, graphql_1.buildClientSchema)(resp.body.data)];
                case 4: return [3 /*break*/, 6];
                case 5:
                    writeLog("loading schema from file \"".concat(pathOrURL, "\""));
                    data = fs_1.default.readFileSync(pathOrURL, "utf8");
                    return [2 /*return*/, (0, graphql_1.buildSchema)(data)];
                case 6: return [2 /*return*/];
            }
        });
    });
}
function graphqlTypescriptCodegen(config) {
    return __awaiter(this, void 0, void 0, function () {
        var writeLog, tsPattern, tsFilePaths, tsFilePathsMap, graphqlPattern, graphqlFilePaths, sources, allImports, _i, graphqlFilePaths_1, input, src, doc, schema, _a, imports, additionalFragments, _b, _c, imp, deps, dep, _d, name_2, frag, data, _e, _f, dir, _g, _h, f, unusedFiles, _j, unusedFiles_1, f, confirmed, _k, unusedFiles_2, f, _l, unusedFiles_3, f;
        return __generator(this, function (_m) {
            switch (_m.label) {
                case 0:
                    writeLog = writeLogFunc(config.quiet);
                    tsPattern = path_1.default.join(config.directory, "**", "*.ts");
                    tsFilePaths = glob_1.default.sync(tsPattern);
                    tsFilePathsMap = lodash_1.default.fromPairs(lodash_1.default.map(tsFilePaths, function (p) { return [p, true]; }));
                    graphqlPattern = path_1.default.join(config.directory, "**", "*.graphql");
                    graphqlFilePaths = glob_1.default.sync(graphqlPattern);
                    sources = [];
                    allImports = [];
                    for (_i = 0, graphqlFilePaths_1 = graphqlFilePaths; _i < graphqlFilePaths_1.length; _i++) {
                        input = graphqlFilePaths_1[_i];
                        writeLog("loading graphql file \"".concat(input, "\""));
                        src = (0, graphql_2.loadGraphQLFromFile)(input);
                        allImports.push.apply(allImports, (0, graphql_2.extractImportSpecs)(src.body));
                        if (src)
                            sources.push(src);
                    }
                    doc = (0, graphql_1.concatAST)(lodash_1.default.map(sources, function (src) { return (0, graphql_1.parse)(src); }));
                    _a = config.schema;
                    if (_a) return [3 /*break*/, 2];
                    return [4 /*yield*/, fetchSchema(writeLog, config.schemaPathOrURL, config.token)];
                case 1:
                    _a = (_m.sent());
                    _m.label = 2;
                case 2:
                    schema = _a;
                    imports = (0, graphql_2.loadImports)(allImports, config.includes, schema, config.embedImports);
                    additionalFragments = {};
                    for (_b = 0, _c = imports.loadedImports; _b < _c.length; _b++) {
                        imp = _c[_b];
                        deps = {};
                        (0, graphql_2.addFragmentDepsRecursive)(deps, [imp.name], imp.context.fragmentDeps, {});
                        for (dep in deps) {
                            _d = lodash_1.default.split(dep, ":", 2), name_2 = _d[1];
                            frag = (0, util_1.nonNull)(imp.context.fragments[name_2], "fragment: ".concat(name_2));
                            additionalFragments[name_2] = {
                                kind: graphql_1.Kind.DOCUMENT,
                                definitions: [frag.node],
                            };
                        }
                    }
                    (0, graphql_2.validateDocument)(schema, (0, graphql_1.concatAST)(__spreadArray([doc], lodash_1.default.compact(lodash_1.default.values(additionalFragments)), true)), config.allowUnusedFragments);
                    data = generate(schema, doc, imports);
                    for (_e = 0, _f = [path_1.default.join(config.directory, "fragments"), path_1.default.join(config.directory, "operations")]; _e < _f.length; _e++) {
                        dir = _f[_e];
                        fs_1.default.mkdirSync(dir, { recursive: true });
                    }
                    writeFileIfChanged(writeLog, path_1.default.join(config.directory, "types.ts"), data.types);
                    delete tsFilePathsMap["".concat(config.directory, "/types.ts")];
                    for (_g = 0, _h = data.files; _g < _h.length; _g++) {
                        f = _h[_g];
                        writeFileIfChanged(writeLog, "".concat(config.directory, "/").concat(f.name), f.text);
                        delete tsFilePathsMap["".concat(config.directory, "/").concat(f.name)];
                    }
                    unusedFiles = lodash_1.default.keys(tsFilePathsMap).sort();
                    if (!(unusedFiles.length > 0)) return [3 /*break*/, 5];
                    if (!config.quiet) return [3 /*break*/, 3];
                    for (_j = 0, unusedFiles_1 = unusedFiles; _j < unusedFiles_1.length; _j++) {
                        f = unusedFiles_1[_j];
                        fs_1.default.renameSync(f, f + ".unused");
                    }
                    return [3 /*break*/, 5];
                case 3:
                    writeLog("the following files are no longer used:\n".concat(lodash_1.default.join(unusedFiles, "\n")));
                    return [4 /*yield*/, (0, prompts_1.default)({
                            type: "confirm",
                            name: "confirmed",
                            message: "delete them?",
                            initial: false,
                        })];
                case 4:
                    confirmed = (_m.sent()).confirmed;
                    if (confirmed) {
                        for (_k = 0, unusedFiles_2 = unusedFiles; _k < unusedFiles_2.length; _k++) {
                            f = unusedFiles_2[_k];
                            writeLog("deleting \"".concat(f, "\""));
                            fs_1.default.unlinkSync(f);
                        }
                    }
                    else {
                        for (_l = 0, unusedFiles_3 = unusedFiles; _l < unusedFiles_3.length; _l++) {
                            f = unusedFiles_3[_l];
                            writeLog("renaming \"".concat(f, "\" to \"").concat(f, ".unused\""));
                            fs_1.default.renameSync(f, f + ".unused");
                        }
                    }
                    _m.label = 5;
                case 5: return [2 /*return*/];
            }
        });
    });
}
exports.graphqlTypescriptCodegen = graphqlTypescriptCodegen;
function contentModelTypescriptCodegen(config) {
    return __awaiter(this, void 0, void 0, function () {
        var writeLog, schemas, resp, _i, _a, data, schema, _b, _c, input, data, schema, r;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    writeLog = writeLogFunc(config.quiet);
                    schemas = [];
                    writeLog("loading built-in content models from api: ".concat(config.api));
                    return [4 /*yield*/, superagent_1.default
                            .post(config.api)
                            .http2()
                            .accept("json")
                            .send([{ method: "GET", url: "info/content_models.json" }])];
                case 1:
                    resp = _d.sent();
                    try {
                        for (_i = 0, _a = resp.body[0].response; _i < _a.length; _i++) {
                            data = _a[_i];
                            schema = (0, content_model_1.parseContentModelSchema)(data.json);
                            writeLog(" - ".concat(schema.name));
                            schemas.push(schema);
                        }
                    }
                    catch (_e) {
                        // do nothing
                    }
                    for (_b = 0, _c = config.input; _b < _c.length; _b++) {
                        input = _c[_b];
                        writeLog("loading content model schema from \"".concat(input, "\""));
                        data = fs_1.default.readFileSync(input, "utf-8");
                        schema = (0, content_model_1.parseContentModelSchema)(data);
                        schemas.push(schema);
                    }
                    writeLog("generating typescript code");
                    r = (0, content_model_1.generateContentModelTypescriptCode)(schemas);
                    if (config.output === "-") {
                        console.log(r);
                    }
                    else {
                        writeFileIfChanged(writeLog, config.output, r);
                    }
                    return [2 /*return*/];
            }
        });
    });
}
exports.contentModelTypescriptCodegen = contentModelTypescriptCodegen;
